///
/// @Describe: 文件大小计算
///
/// @Author: LiWeNHuI
/// @Date: 2021/9/28
///

String fileSize(dynamic fileSize, [int round = 2]) {
  var bDivider = 1024;
  int size;
  try {
    size = int.parse(fileSize.toString());
  } catch (e) {
    throw ArgumentError('Can not parse the size parameter: $e');
  }

  var uRound = size % bDivider == 0 ? 0 : round;

  if (size < bDivider) {
    return '$size B';
  }

  var kbDivider = bDivider * bDivider;
  if (size < kbDivider) {
    return '${(size / bDivider).toStringAsFixed(uRound)} KB';
  }

  var mbDivider = kbDivider * bDivider;
  if (size < mbDivider) {
    return '${(size / kbDivider).toStringAsFixed(uRound)} MB';
  }

  var gbDivider = mbDivider * bDivider;
  if (size < gbDivider) {
    return '${(size / mbDivider).toStringAsFixed(uRound)} GB';
  }

  var tbDivider = gbDivider * bDivider;
  if (size < tbDivider) {
    return '${(size / gbDivider).toStringAsFixed(uRound)} TB';
  }

  var pbDivider = tbDivider * bDivider;
  if (size < pbDivider) {
    return '${(size / tbDivider).toStringAsFixed(uRound)} PB';
  }

  /// 目前还没有单个存储器达到这个容量
  var ebDivider = pbDivider * bDivider;
  if (size < ebDivider) {
    return '${(size / pbDivider).toStringAsFixed(uRound)} EB';
  }

  return '${(size / pbDivider).toStringAsFixed(round)} EB';
}
